<?php

/* MODEL */

$STRONY = [
  ['id'=>'1',  'name'=>"Katedra",      'href'=>"index.php" ],
  ['id'=>'2',  'name'=>"Kadra",        'href'=>"extnwd.php"],
  ['id'=>'3',  'name'=>"Studenci",     'href'=>"qsort.php" ],
  ['id'=>'4',  'name'=>"Aktualności",  'href'=>"msort.php" ]
];
 
/* VIEW */

$HEADER_0 =<<<EOT
<!DOCTYPE html>
<html lang="pl">
<head>
  <meta charset="utf-8">
  <title>{{TITLE}}</title>
  <meta name="description" content= "{{DESCRIPTION}}">
  <meta name="keywords" content= "{{KEYWORDS}}">  
  <link rel="icon" type="image/png" href="img/favicon-32x32.png" sizes="32x32" />
  <link rel="icon" type="image/png" href="img/favicon-16x16.png" sizes="16x16" />
  <meta name="viewport" content= "width=device-width, initial-scale=1.0"/>
EOT;

$HEADER_1 =<<<EOT
</head>

<body>
<div class="container">
<nav class="navbar">
<ul>
{{ITEMS}}</ul>
</nav>

EOT;

$FOOTER = <<<EOT
<footer id="mainfooter">
Copyright &copy 2016 WPPT
</footer>
</div> <!-- container -->
</body>
</html>
EOT;

/* CONTROLLER */

class WPPTPage{
  private $id = '';
  private $Title = "";
  private $description = "";
  private $keywords    = "Politechnika Wrocławska, WPPT, Katedra Informatyyki";
  private /*. string[int] .*/$css      = [];
  private /*. string[int] .*/$jsfiles  = [];
  
  public function AddCSS(/*. string .*/ $s) {
    $this->css[] = (string) str_replace("{{C}}", $s, 
	"<link href='css/{{C}}' rel='stylesheet'>");
  }

  public function AddJS(/*. string .*/ $s) {
    $this->css[] = (string) str_replace("{{J}}", $s, "<script src='js/{{J}}'></script>");
  }

  public function SetDescription(/*. string .*/ $s) {
    $this->description = $s;
  }

  public function AddKeywords(/*. string .*/ $s) {
    $this->keywords.= "," . $s;
  }

  /**
  * @param string $id
  * @return void
  **/
  function __construct($id, $T = "") {
    $this->id    = $id;
    $this->Title = $T;
    $this->AddCSS("mystyle.css");
  }

  /**
  * @return string
  **/
  private function Menu() {
    global $STRONY;
    $ITEM   = "<li><a href='{{HREF}}'>{{NAME}}</a></li>";
    $ACTIVE = "<li class='active'>{{NAME}}</li>";
    $S = "";
    for ($i=0; $i<count($STRONY); $i++){
      
      if ($STRONY[$i]["id"]===$this->id) {
        $T= $ACTIVE;
      } else {
        $T= (string) str_replace("{{HREF}}", $STRONY[$i]["href"], $ITEM);
      };
      
      $T = (string) str_replace("{{NAME}}" , $STRONY[$i]["name"],  $T);
      $S.= $T . "\n";
    }
    return $S;
  }

  /**
  * @return string
  **/
  public function Begin() {
    //var_dump($this->css);
    global $HEADER_0, $HEADER_1;

    $S = (string) str_replace("{{TITLE}}", $this->Title,  $HEADER_0);
    $S = (string) str_replace("{{ITEMS}}", $this->Menu(), $S);
    $S = (string) str_replace("{{DESCRIPTION}}", $this->description, $S);
    $S = (string) str_replace("{{KEYWORDS}}", $this->keywords, $S);

    // dodajemy style    
    $X = "";
    for ($i=0;$i<count($this->css);$i++) {
      $X.= "  " .$this->css[$i] . "\n";
    }
    if ($X !== "") {
      $S.= "\n" . $X . "\n";
    }

    // Dodajemy javascript'y
    $X = "";
    for ($i=0;$i<count($this->jsfiles);$i++) {
      $X.= $this->jsfiles[$i] . "\n";
    }
    if ($X !== "") {
      $S.= "\n" . $X;
    }
    //Wstawiamy menu
    $S.= (string) str_replace("{{ITEMS}}", $this->Menu(), $HEADER_1);
    // usuwamy puste linie
    return preg_replace('/^\h*\v+/m', '', $S);
  }

  /**
  * @return string
  **/
  public function End() {
    global $FOOTER;
    return $FOOTER;
  }
}
?>