<?php
require_once("PHP/MyDatabase.php");
require_once("PHP/MyPage.php");

$EDYTOR_NOWEGO = <<<EOT
<h1>Mój nowy wpis</h1>
<form method="post" action="myblogB.php?do=save" id="forma">
<label for="fTitle">Tytul</label> 
<input type="text" name = "tytul" size="40" maxlength="120" placeholder="Tytul wpisu" required id="fTitle"> 
<br>
<label for = "fInfo">Treść</label>
<textarea rows = "10" cols = "60" name = "info" placeholder="Wpisz swoją uwagę ..." required id="fInfo">
</textarea>
<br>
<input type="submit" value="Zapisz" class="btn-b smooth">
</form>
<hr>
<a class="btn btn-a smooth" href="myBlogA.php">Powrót</a>
EOT;

$EDYTOR_STAREGO = <<<EOT
<h1>Edycja istniejącego wpisu</h1>
<form method="post" action="myblogB.php?do=update" id="forma">
<label for="fTitle">Tytul</label> 
<input type="text" name = "tytul" size="40" maxlength="120" placeholder="Tytul wpisu" required id="fTitle" value = "{{TYTUL}}"> 
<br>
<label for = "fInfo">Treść</label>
<textarea rows = "10" cols = "60" name = "info" placeholder="Wpisz swoją uwagę ..." required id="fInfo">
{{INFO}}
</textarea>
<br>
<input type="hidden" value="{{ID}}" name = "id">
<input type="submit" value="Zapisz" class="btn-b smooth">
</form>
<hr>
<a class="btn btn-a smooth" href="myBlogA.php">Powrót</a>
EOT;

function PreparePage(){
	$P = new WPPTPage('2',"Kadra Katedry Informatyki WPPT PWr");
	$P->SetDescription("Mój blog");
	$P->AddKeywords("opinie, uwagi");
	$P->AddCSS("kadra.css");
	$P->AddCSS("blog.css");
	return $P;
}
	
function WyswietlNowyFormularz(){
	global $EDYTOR_NOWEGO;
	$P = PreparePage();
	echo $P->Begin();	
	echo $EDYTOR_NOWEGO;
	echo $P->End();
}

function WyswietEdytor($id){
	global $EDYTOR_STAREGO;
	$P = PreparePage();
	echo $P->Begin();	
	if (filter_var($id, FILTER_VALIDATE_INT)===false){
		$id = 0;
	}
	$db = myDB();
	$wpis = myDbSelect($db,"SELECT * FROM blog WHERE Id = '$id';");
	if (sizeof($wpis)===1){
		$tytul = $wpis[0]["Tytul"];
		$info  = trim($wpis[0]["Info"]);
		$S = str_replace(["{{TYTUL}}","{{INFO}}","{{ID}}"],[$tytul,$info,$id],$EDYTOR_STAREGO);
		echo $S;
	} else {
	}
	echo $P->End();
}

// Operacje bazo - danowe 

function ZapiszNowyFormularz(){
	$data  = date('Y-m-d');
	$tytul = $_REQUEST["tytul"];
	$info  = $_REQUEST["info"];

	//usuwamy większność tagów HTML
	$tytul = trim(strip_tags($tytul));
	$info  = trim(strip_tags($info,"<br><em><strong><p>"));

	$db = myDB();
	
	//używamy tylko "prepared queries" - to jest standard produkcyjny
	$stmt = $db->prepare("INSERT INTO blog(Data,Tytul,Info) VALUES (?,?,?)");
	$stmt-> bind_param("sss", $data, $tytul, $info);

	if ($stmt -> execute()){
		header("Location: myblogA.php");
	} else {
		header("Location: myBLogB.php?do=error");
	}
	exit;
}

function Aktualizuj($id){
	$data  = date('Y-m-d');
	$tytul = $_REQUEST["tytul"];
	$info  = $_REQUEST["info"];
	$db    = myDB();
	$stmt  = $db->prepare("UPDATE blog SET Data = ?, Tytul = ?, Info = ? WHERE Id = ?");
	$stmt-> bind_param("sssi", $data, $tytul, $info, $id);
	if ($stmt -> execute()){
		header("Location: myblogA.php");
	} else {
		header("Location: myBLogB.php?do=error&errtype=update");
	}
	exit;	
}

// Obsługa błędów

function WyswietlBlad(){
	$P = PreparePage();
	echo $P->Begin();
	echo "O kurcze: błąd bazy !!!!!!!!!!!!!!!!!";
	echo $P->End();
}

// STEROWANIE

$what = (isset($_REQUEST['do'])?$_REQUEST['do']:"");
$id   = intval(isset($_REQUEST['id'])?$_REQUEST['id']:"0");
$err = 
switch ($what){
	case "save"  : 
		ZapiszNowyFormularz(); 
		break;
	case "edit" : 
		WyswietEdytor($id);
		break;
	case "update" :
		Aktualizuj($id);
		break;
	case "error" : 
		WyswietlBlad();    
		break;
	default:
		WyswietlNowyFormularz();
}
?>  